/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.gruppeimgebiet;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.gruppeimgebiet.boundary.AbstractGruppeImGebietSearchParameters;
import de.ivu.elect.business.gruppeimgebiet.boundary.GruppeImGebietChangeEvent;
import de.ivu.elect.business.gruppeimgebiet.boundary.GruppeImGebietConversationStore;
import de.ivu.elect.business.gruppeimgebiet.boundary.GruppeImGebietExtendedDAO;
import de.ivu.elect.business.gruppeimgebiet.boundary.GruppeImGebietSearch;
import de.ivu.elect.business.gruppeimgebiet.boundary.GruppeImGebietSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet;
import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractGruppeImGebietSearchView.COMPONENT_NAME)
@View(viewId = AbstractGruppeImGebietSearchView.VIEW_ID, useCase = UseCasePermission.GRUPPE_IM_GEBIET_SEARCH)
public abstract class AbstractGruppeImGebietSearchView extends AbstractElectSearchView<GruppeImGebiet> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gruppeImGebietSearchView";
  
  public static final String VIEW_ID = "/gruppeimgebiet/gruppe-im-gebiet-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractGruppeImGebietSearchView requestHandler;

  @Inject
  private transient GruppeImGebietExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(GruppeImGebietConversationStore.class)
  protected transient GruppeImGebietConversationStore conversationStore;

  @Inject
  protected transient GruppeImGebietSearch search;

  @Inject
  @ConversationGroup(AbstractGruppeImGebietSearchParameters.class)
  protected transient GruppeImGebietSearchParameters searchParameters;

  @Inject
  protected transient GruppeImGebietMeta entityMeta;

  public AbstractGruppeImGebietSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public GruppeImGebiet getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(GruppeImGebiet entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public GruppeImGebietSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<GruppeImGebiet> getEagerLoadingCollector() {
    return EagerLoadingCollector.<GruppeImGebiet> create();
  }

  @Override
  public List<GruppeImGebiet> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<GruppeImGebiet> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onGruppeImGebietChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) GruppeImGebietChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractGruppeImGebietSearchView {

    @View
    @Inject
    private transient Instance<AbstractGruppeImGebietSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractGruppeImGebietSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
